﻿program Main;
  const
    im = 500;
    nums_section = 10;
    FileWing = 'TEMP\wing.ism';
    FileWingSet = 'TEMP\wingset.ism';
    FileWingLoad = 'TEMP\wingload.ism';
    FileShForce = 'TEMP\shforce.ism';
    FileBendMom = 'TEMP\bendmom.ism';
    ScriptWing = '.wingscr';
    FileSpar = 'TEMP\spar.ism';
    esf20 = 20;
    esf12 = 12;
    esf4 = 4;
    isf7 = 7;
    
  type
    section = array [0..nums_section] of real;
    mesh = array [0..im] of real;
    
  var
    mass:real := 0.5;
    gforce:real := 9.8;
    fsafe:real := 7.5;
    overld:real := 10;
    name,dir: string;
    WingFile, WingSetFile, WingLoadFile,
    ShForceFile, BendMomFile, ScriptFile, SparFile: text;
  	fexists: boolean;
  	lplane: boolean := false;
  	lwing : boolean := false;
  	lwload: boolean := false;
  	lshfor: boolean := false;
  	lbemom: boolean := false;
  	lspar : boolean := false;
  	lexit : boolean := false;
  	comand: string;
  	
  	
  procedure Welkom();
    var
      wr:string;
      beg:text;
      
    begin
      assign(beg,'Salem.wlkm');
      reset(beg);
      while(not(eof(beg))) do
      begin
        readln(beg,wr);
        writeln(wr);
      end;
      close(beg);
      sleep(1000);
    end;
  
  procedure WrBeg();
    var
      wr:string;
      beg:text;
      
    begin
      assign(beg,'WrBeg.aux');
      reset(beg);
      while(not(eof(beg))) do
      begin
        readln(beg,wr);
        writeln(wr);
        sleep(50);
      end;
      close(beg);
      sleep(2000);
    end;
  
  procedure Arnie();
    var
      Schwarzenegger:string;
      Arnold:text;
      
    begin
      assign(Arnold,'Arnie.aux');
      reset(Arnold);
      while(not(eof(Arnold))) do
      begin
        readln(Arnold,Schwarzenegger);
        writeln(Schwarzenegger);
        sleep(50);
      end;
      close(Arnold);
      sleep(2000);
    end;
  
  procedure Terminate();
    var
      Schwarzenegger:string;
      Arnold:text;
      
    begin
      assign(Arnold,'Terminate.aux');
      reset(Arnold);
      while(not(eof(Arnold))) do
      begin
        readln(Arnold,Schwarzenegger);
        writeln(Schwarzenegger);
        sleep(50);
      end;
      close(Arnold);
      sleep(2000);
    end;
  
  procedure SPARSTRENGH();
    begin
      writeln('################################################');
      writeln;
      writeln('           ####  #####   ####  #####            ');
      writeln('          ##     ##  ## ##  ## ##  ##           ');
      writeln('           ####  #####  ###### #####            ');
      writeln('              ## ##     ##  ## ##  ##           ');
      writeln('           ####  ##     ##  ## ##  ##           ');
      writeln(' ####  ###### #####  #####  ##  ##  ####  ##  ##');
      writeln('##       ##   ##  ## ##     ### ## ##     ##  ##');
      writeln(' ####    ##   #####  ####   ## ### ## ### ######');
      writeln('    ##   ##   ##  ## ##     ##  ## ##  ## ##  ##');
      writeln(' ####    ##   ##  ## #####  ##  ##  ####  ##  ##');
      writeln;
      writeln('KUAT ISMAILOV, MENDIKJAN@FTF.TSU.RU');
      writeln('               MENDIKJAN@GMAIL.COM');
      writeln;
      writeln('################################################');
      writeln;
    end;
    
  function Naam():string;
    var
      ans:char;
      logic:boolean := true;
      name:string;
      
    begin
      write(' Введите имя: ');
      while (logic) do
        begin
          readln(name);
          if ((name='exit') or (name='EXIT')) then
            begin
            writeln(' Программа прервана Пользователем ');
            halt;
            end;
		  
          logic := FileExists(name+'\Spar.dat');
          
          if (logic) then
            begin
              writeln;
              write(' РЕШЕНИЕ СУЩЕСТВУЕТ !!! '); sleep(1000);
              writeln(' РЕШЕНИЕ СУЩЕСТВУЕТ !!! '); sleep(1000);
              writeln(' ПОЗВОЛЬТЕ МЕНЯ СПРОСИТЬ ВАС ');
              writeln; sleep(1000);
			  write(' ЖЕЛАЕТЕ ЛИ ВЫ ИЗМЕНИТЬ ИМЯ (Y/N): ');
              readln(ans);
              if ((ans='y') or (ans='Y')) then
                begin
                  write(' Введиде новое имя: ');
                  continue;
                end
              else
      				begin
      				  writeln;
      					writeln(' Ok. Перезаписываем решение :-( ');
      					sleep(1000);
      					break;
      				end;
            end
          else
            MkDir(name);
        end;
      writeln;
      result := name;
    end;
      
  procedure Set_Plane();
    var
      hspan, area, x: real;
      n, num_section: integer;
      chordsec, thicksec, sweepsec, dihedsec, twistsec, coord: section;
      
    begin
      
      n := 0;
      x := 1;
      
      while (not(x=0)) do
        begin
          if (n=0) then
            begin
              write(' Введите координаты Корневой хорды (мм): ');
              readln(coord[n]);
              coord[n] := coord[n]*0.001;
            end
          else
            begin
              writeln;
              write(' Введите длину вдоль размаха секции #',n,' (мм): ');
              readln(x);
              if (x=0) then
                begin
                  n := n-1;
                  break;
                end;
              if (x<0) then x := abs(x);
              coord[n] := coord[n-1] + x*0.001;
            end;
            
          write(' Введите длину Хорды крыла в сечении #',n,' (мм): ');
          readln(chordsec[n]);
          chordsec[n] := chordsec[n]*0.001;
          
          write(' Введите Толщину крыла в сечении #',n,' (%): ');
          readln(thicksec[n]);
          
          if (not(n=0)) then
            begin
              write(' Введите смещение Х сечения #',n,' от 0-хорды (стреловидность) (мм): ');
              readln(sweepsec[n]);
              sweepsec[n] := sweepsec[n]*0.001;
            end;
          
          write(' Введите угол поперечного V в сечении #',n,' (мм): ');
          readln(dihedsec[n]);
          dihedsec[n] := dihedsec[n];
          
          write(' Введите угол крутки крыла в сечении #',n,' (мм): ');
          readln(twistsec[n]);
          twistsec[n] := twistsec[n];
          
          n := n + 1;
          
        end;
        
        num_section := n;
        
        writeln;
        writeln(' Консоль крыла состоит из ',n,' секций');
        writeln(' Размах крыла: ',2*coord[n]*1000, ' (мм)');
        sleep(1000);
        hspan := coord[n];
        
      /// Wing area
        area := 0;
        for n:=1 to num_section do
          area := area + ( chordsec[n-1] + chordsec[n] )*0.5*( coord[n] - coord[n-1] );
        area := 2*area;
        
        writeln(' Площадь крыла: ',area*100,' (дм2)');
        writeln;
        
        write(' Введите вес самолета (г): ');
        readln(mass);
          if (mass=0) then
            begin
              writeln(' Позвольте объяснить, что в таком случае Вы здесь делаете?');
              sleep(3000);
              writeln(' Вес самолета равен весу Колибри :-) ');
              sleep(2000);
              mass := 20;
            end;
            mass := mass*0.001;
            writeln(' Нагрузка на крыло: ',mass*10/area,' (г/дм2)');
        write(' Введите ускорение свободного падения G (9.8) (м/с2): ');
          readln(gforce); if (gforce<=0) then gforce := 9.81; writeln('     G-force: ',gforce);
        write(' Введите коэффициент безопасности (запас прочности) (1.5): ');
          readln(fsafe); if (fsafe<=0) then fsafe := 7.5; writeln('     Safe Factor:',fsafe);
        write(' Введите коэффициент перегрузки (10.0 по умол): ');
          readln(overld); if (overld<=0) then overld := 10; writeln('     Overload: ',overld);
        writeln;
        
        write(' Запись данных во временный файл... ');
        assign(WingFile,FileWing);
        rewrite(WingFile);
        writeln(WingFile,'# Wing and Plane set table');
        writeln(WingFile,'# Plane mass, G-Force, Safety coef, G-Force overload, Wing area');
        writeln(WingFile,'# Half-span, number of sections');
        writeln(WingFile,'# absolute coord, chord, thickness, sweep, dihedral, twist in the profile cut');
        
/// Writing Plane mass, Gravity force acceleration, safety coefficient, G-force overload, wing area
        writeln(WingFile,mass:esf12:esf4, gforce:esf12:esf4, fsafe:esf12:esf4, overld:esf12:esf4, area:esf12:esf4);
/// Writing Half-span, number of sections
        writeln(WingFile,hspan:esf12:esf4, num_section:isf7);
/// Writing absolute coord, chord, thickness, sweep, dihedral, twist in the profile cut
        for n:=0 to num_section do
          writeln(WingFile,coord[n]:esf12:esf4, chordsec[n]:esf12:esf4, thicksec[n]:esf12:esf4, sweepsec[n]:esf12:esf4, dihedsec[n]:esf12:esf4, twistsec[n]:esf12:esf4);
        close(WingFile);
        writeln('Ok');
          
    end;
        
  procedure Set_Wing();
    var
      hspan, z, dz, dx, area: real;
      chord, thick, sweep, dihed, twist: mesh;
      coord, chordsec, thicksec, sweepsec, dihedsec, twistsec: section;
      i, n, ik, num_section: integer;
      i0_section, ik_section: integer;
    
    begin
      
      write(' Чтение из временного файла... ');
      assign(WingFile,FileWing);
      reset(WingFile);
      readln(WingFile); readln(WingFile); readln(WingFile); readln(WingFile);
/// Reading Plane mass, Gravity force acceleration, safety coefficient, G-force overload, wing area
      readln(WingFile,mass, gforce, fsafe, overld, area);
/// Reading Half-span, num_section
      readln(WingFile,hspan, num_section);
/// Reading absolute coord, chord, thickness, sweep, dihedral, twist in the profile cut
      for n:=0 to num_section do
        readln(WingFile, coord[n],chordsec[n], thicksec[n], sweepsec[n], dihedsec[n], twistsec[n]);
      close(WingFile);
      writeln('Ok');
      
      writeln;
      writeln(' Крыло состоит ',num_section,' секций');
      sleep(1000);
      
      writeln(' Разбиение крыла на расчетную сетку. ik: min = 50, max = 500 ');
      write(' Введите число точек сетки: ');
      readln(ik);
        if (ik<50) then ik := 50;
        if (ik>500) then ik:=500;
        
        dz := 1/ik;
        dx := hspan/ik;
        
        n := 1;
        
      while (n<=num_section) do
        begin
          i0_section := round(coord[n-1]/dx);
          ik_section := round(coord[n]/dx);
          
          for i:= i0_section to ik_section do
            begin
              z := (i*dx - coord[n-1])/(coord[n] - coord[n-1]);
              chord[i] := chordsec[n-1] + ( chordsec[n] - chordsec[n-1] )*z;
              thick[i] := thicksec[n-1] + ( thicksec[n] - thicksec[n-1] )*z;
              sweep[i] := sweepsec[n-1] + ( sweepsec[n] - sweepsec[n-1] )*z;
              dihed[i] := dihedsec[n-1] + ( dihedsec[n] - dihedsec[n-1] )*z;
              twist[i] := twistsec[n-1] + ( twistsec[n] - twistsec[n-1] )*z;
            end;
            
          writeln('     Секция #',n,' обновлена');
          n := n+1;
        end;
        
        write(' Запись данных во временный файл... ');
        assign(WingSetFile,FileWingSet);
        rewrite(WingSetFile);
        writeln(WingSetFile,'#Wing set table');
        writeln(WingSetFile,'# Plane set: mass, G-force, Safety coef, G-force Overload, wing area');
        writeln(WingSetFile,'# half-span, number of divisions');
        writeln(WingSetFile,'# coord z=2*x/L, Chord, Thickness (%), Sweep, Dihedral, Twist');
/// Writing Plane mass, Gravity force acceleration, safety coefficient, G-force overload, wing area
        writeln(WingSetFile,mass:esf12:esf4, gforce:esf12:esf4, fsafe:esf12:esf4, overld:esf12:esf4, area:esf12:esf4);
/// Writing half-span, mesh size
        writeln(WingSetFile, hspan:esf12:esf4, ik:isf7);
/// Writing coordinate Z (2*X/L), chord, w/o thickness, sweep, dihedral, twist
        for i:=0 to ik do
          begin
            z := i*dz;
            writeln(WingSetFile, z:esf12:esf4, chord[i]:esf12:esf4, thick[i]:esf12:esf4, sweep[i]:esf12:esf4, dihed[i]:esf12:esf4, twist[i]:esf12:esf4);
          end;
        close(WingSetFile);
        writeln('Ok');
        
      end;

  function plane_script(name:string;logic:boolean):boolean;
    var
      hspan:real;
      n,num_section:integer;
      coord,chordsec,thicksec,sweepsec,dihedsec,twistsec:section;
      fromscr,toscr:string;
      mass, gforce, fsafe, overld, area:real;
      fexist:boolean;
      
    begin
    
      fexist := FileExists(name+ScriptWing);
      
      if (not(fexist) and logic) then
        begin
          writeln(' Error!');
          writeln(' File is not exist!!! ');
          result := false;
          exit;
        end;
        
      if (logic) then
        begin
          fromscr := name + ScriptWing;
          toscr := FileWing;
        end
      else
        begin
          fromscr := FileWing;
          toscr := name + ScriptWing;
        end;
        
      if (logic) then write(' Чтение скрипт-файла... ')
      else write(' Чтение временного файла... ');
      
      
          assign(ScriptFile,fromscr);
          reset(ScriptFile);
          readln(ScriptFile);readln(ScriptFile);
          readln(ScriptFile);readln(ScriptFile);
/// Reading Plane mass, Gravity force acceleration, safety coefficient, G-force overload, wing area
          readln(ScriptFile,mass,gforce,fsafe,overld,area);
/// Reading Half-span, number of sections
          readln(ScriptFile,hspan, num_section);
/// Reading absolute coord, chord, thickness, sweep, dihedral, twist in the profile cut
          for n := 0 to num_section do
            readln(ScriptFile,coord[n], chordsec[n], thicksec[n], sweepsec[n], dihedsec[n], twistsec[n]);
          close(ScriptFile);
          writeln('Ok');
        
        if (logic) then write(' Запись во временный файл... ')
        else write(' Запись в скрипт-файл... ');
        
        assign(ScriptFile,toscr);
        rewrite(ScriptFile);
          writeln(ScriptFile,'# Wing and Plane set table');
          writeln(ScriptFile,'# Plane mass, G-force, safety coef, G-force overload, wing area');
          writeln(ScriptFile,'# Half-span, number of sections');
          writeln(ScriptFile,'# absolute coord, chord, thickness, sweep, dihedral, twist in the profile cut');
/// Reading Plane mass, Gravity force acceleration, safety coefficient, G-force overload, wing area
          writeln(ScriptFile,mass:esf12:esf4,gforce:esf12:esf4,fsafe:esf12:esf4,overld:esf12:esf4,area:esf12:esf4);
/// Reading Half-span, number of sections
          writeln(ScriptFile,hspan:esf12:esf4,num_section:isf7);
/// Reading absolute coord, chord, thickness, sweep, dihedral, twist in the profile cut
          for n := 0 to num_section do
            writeln(ScriptFile,coord[n]:esf12:esf4,chordsec[n]:esf12:esf4,thicksec[n]:esf12:esf4,sweepsec[n]:esf12:esf4,dihedsec[n]:esf12:esf4,twistsec[n]:esf12:esf4);
        close(ScriptFile);
        writeln('Ok');
        writeln;
        writeln(' Данные обновлены');
        writeln;
        
        if (logic) then
          begin
            writeln(' Размах крыла (мм): ',2*hspan);
            writeln(' Площадь крыла (дм2): ', area*100);
            writeln(' Вес аппарата (г): ',mass*1000);
            writeln(' Нагрузка на крыло (г/дм2): ',mass*10/area);
            writeln(' Ускорение свободного падения (м/с2): ',gforce);
            writeln(' Коэффициент безопасности (запас прочности): ',fsafe);
            writeln(' Коэффициент перегрузки: ',overld);
          end;
       
       result := true;
       
    end;
  
  procedure WingLoad();
    var
      hspan, z, dz:real;
      i,ik:integer;
      mass, gforce, fsafe, overld, area:real;
      chord,wload: mesh;
    
    begin
      
      write(' Чтение временного файла... ');
      assign(WingSetFile,FileWingSet);
      reset(WingSetFile);
      readln(WingSetFile); readln(WingSetFile); readln(WingSetFile); readln(WingSetFile);
/// Reading Plane mass, Gravity force acceleration, safety coefficient, G-force overload, wing area
      readln(WingSetFile, mass, gforce, fsafe, overld, area);
/// Reading half-span, mesh size
      readln(WingSetFile, hspan, ik);
      
/// Reading coordinate Z (2*X/L), chord, w/o thickness, sweep, dihedral, twist
      for i := 0 to ik do
        begin
          readln(WingSetFile, z, chord[i]);
        end;
      close(WingSetFile);
      writeln('Ok');
      
      
/// Computing the Shearing Forces
      write(' Расчет распределения подъемной силы ... ');
      for i := ik downto 0 do
        wload[i] := fsafe*overld*gforce*0.5*mass*chord[i]/area;
      writeln('Ok');
      
/// Writing Shearing Forces to temporaru file      
      write(' Запись данных во временный файл... ');
      assign(WingLoadFile,FileWingLoad);
      rewrite(WingLoadFile);
      writeln(WingLoadFile,'# Shearing Forces table');
      writeln(WingLoadFile,'# half-span, number of divisions');
      writeln(WingLoadFile,'# coord z=2*x/L, shforce');
      writeln(WingLoadFile, hspan:esf12:esf4, ik:isf7);
        dz := 1/ik;
      for i:= 0 to ik do
        begin
          z := i*dz;
          writeln(WingLoadFile,z:esf12:esf4, wload[i]:esf12:esf4);
        end;
      close(WingLoadFile);
      writeln('Ok');
      
    end;

  procedure ShForce();
    var
      hspan, z, dz: real;
      i,ik:integer;
      wload, shfor: mesh;
      
    begin
      
      write(' Чтение данных из временного файла... ');
      assign(WingLoadFile,FileWingLoad);
      reset(WingLoadFile);
      readln(WingLoadFile); readln(WingLoadFile); readln(WingLoadFile);
/// Reading Half-span, mesh size
      readln(WingLoadFile, hspan, ik);
/// Reading coordinate Z = 2*(X/L), Wing load
      for i := 0 to ik do
        readln(WingLoadFile, z, wload[i]);
      close(WingLoadFile);
      writeln('Ok');
      
      
/// Computing the Shearing Forces
      write(' Расчет перерезывающих сил... ');
      shfor[ik] := 0;
      dz := 1/ik;
      for i := ik-1 downto 0 do
        shfor[i] := shfor[i+1] + 0.5*( wload[i+1] + wload[i] )*dz;
      writeln('Ok');
      
      
      write(' Запись данных во временный файл... ');
      assign(ShForceFile,FileShForce);
      rewrite(ShForceFile);
      writeln(ShForceFile,'# Shearing Forces table');
      writeln(ShForceFile,'# half-span, number of divisions');
      writeln(ShForceFile,'# coord z=2*x/L, shforce');
      writeln(ShForceFile, hspan:esf12:esf4, ik:isf7);
      for i := 0 to ik do
        begin
          z := i*dz;
          writeln(ShForceFile, z:esf12:esf4, shfor[i]:esf12:esf4);
        end;
      close(ShForceFile);
      writeln('Ok');
      
    end;
  
  procedure BendMom();
    var
      hspan, z, dz: real;
      i,ik:integer;
      shfor, bemom: mesh;
      
    begin
      
      write(' Чтение данных из временного файла... ');
      assign(ShForceFile,FileShForce);
      reset(ShForceFile);
      readln(ShForceFile); readln(ShForceFile); readln(ShForceFile);
/// Reading Half-span, mesh size
      readln(ShForceFile, hspan, ik);
/// Reading coordinate Z = 2*(X/L), Wing load
      for i := 0 to ik do
        readln(ShForceFile, z, shfor[i]);
      close(ShForceFile);
      writeln('Ok');
      
      
/// Computing the Shearing Forces
      write(' Расчет изгибающего момента... ');
      bemom[ik] := 0;
      dz := 1/ik;
      for i := ik-1 downto 0 do
        bemom[i] := bemom[i+1] + 0.5*( shfor[i+1] + shfor[i] )*dz;
      writeln('Ok');
      
      
      write(' Запись данных во временный файл... ');
      assign(BendMomFile,FileBendMom);
      rewrite(BendMomFile);
      writeln(BendMomFile,'# Bending Momentum table');
      writeln(BendMomFile,'# half-span, number of divisions');
      writeln(BendMomFile,'# coord z=2*x/L, bendmom');
      writeln(BendMomFile, hspan:esf12:esf4, ik:isf7);
      for i := 0 to ik do
        begin
          z := i*dz;
          writeln(BendMomFile, z:esf12:esf4, bemom[i]:esf12:esf4);
        end;
      close(BendMomFile);
      writeln('Ok');
      
    end;
      
  procedure sparcalc();
    const
      nums_spar = 5;
      sosna_r = 103;  sosna_s = 48.5;
      el_r = 103;     el_s = 44.5;
      bereza_r = 168; bereza_s = 55;
      dural_d16 = 390;
      carbon = 500;
    var
      spar_width, spar_thick: mesh;
      // spar_width, spar_thick: array[1..nums_spar] of mesh;
      // num_spar: integer;
      i, ik: integer;
      chord, thick, sweep, dihed, twist: mesh;
      bemom: mesh;
      mass, gforce, fsafe, overld, area: real;
      hspan, z, dz, high, minth, sigma: real;
      
    begin
      
      write(' Чтение временного файла... ');
      assign(WingSetFile,FileWingSet);
      reset(WingSetFile);
      readln(WingSetFile);readln(WingSetFile);
      readln(WingSetFile);readln(WingSetFile);
/// Reading Plane mass, Gravity force acceleration, safety coefficient, G-force overload, wing area      
      readln(WingSetFile, mass, gforce, fsafe, overld, area);
/// Reading half-span, mesh size
      readln(WingSetFile, hspan, ik); 
/// Reading coordinate Z (2*X/L), chord, w/o thickness, sweep, dihedral, twist
      for i := 0 to ik do
        readln(WingSetFile, z, chord[i], thick[i], sweep[i], dihed[i], twist[i]);
      close(WingSetFile);
      writeln('Ok');
      
      write(' Чтение временного файла... ');
      assign(BendMomFile,FileBendMom);
      reset(BendMomFile);
      readln(BendMomFile);readln(BendMomFile);readln(BendMomFile);
      readln(BendMomFile, hspan, ik);
      for i := 0 to ik do
        readln(BendMomFile, z, bemom[i]);
      close(BendMomFile);
      writeln('Ok');
      
      writeln;
      writeln(' Введите предел прочности материала лонжерона (МПа)');
      writeln(' или Выберите материал лонжерона из списка');
      writeln('     1 - сосна       ( +',sosna_r  ,' МПа, -',sosna_s ,' МПа )');
      writeln('     2 - ель         ( +',el_r     ,' МПа, -',el_s    ,' МПа )');
      writeln('     3 - береза      ( +',bereza_r ,' МПа, -',bereza_s,' МПа )');
      writeln('     4 - дюраль Д16  (  ',dural_d16,' МПа )');
      writeln('     5 - углепластик (  ',carbon   ,' МПа )');
      write(' Предел прочности (МПа)/ номер материала: ');
      readln(sigma);
        if (sigma = 1) then
          sigma := min(sosna_r,sosna_s)
        else if (sigma = 2) then
          sigma := min(el_r,el_s)
        else if (sigma = 3) then
          sigma := min(bereza_r,bereza_s)
        else if (sigma = 4) then
          sigma := dural_d16
        else if (sigma = 5) then
          sigma := carbon
        else if (sigma < 100) then
          begin
            writeln(' Непрочный материал. Используйте березу :-) ');
            sigma := min(bereza_r,bereza_s);
          end;
          
        sigma := sigma*1e6;
        
        minth := thick[0]*chord[0]/100;
        for i := 1 to ik do
          begin
            z := thick[i]*chord[i]/100;
            if ( z < minth ) then minth := z;
          end;
          
        writeln(' Максимально допустимая толщина полки лонжерона (мм): ',minth/2*1e3);
        write(' Введите толщину полки лонжерона, мм (по умол 2 мм): ');
        readln(z); if (z<=0) then z := 2;
        for i := 0 to ik do
          spar_thick[i] := z*1e-3;
          
        for i := 0 to ik do
          begin
            high := thick[i]*chord[i]/100 - spar_thick[i];
            if (high<spar_thick[i]) then high := spar_thick[i];
            spar_width[i] := bemom[i]/(high*spar_thick[i]*sigma);
          end;
          
        write(' Запись во временный файл... ');
        assign(SparFile,FileSpar);
        rewrite(SparFile);
        writeln(SparFile,'# Constant Spar thickness width table');
        writeln(SparFile,'# half-span, number of divisions');
        writeln(SparFile,'# coord z=2*x/L, spar width, spar thickness');
        writeln(SparFile,'# sigma - sthrengh limit of the Spar meterial, MPa');
        writeln(SparFile,hspan:esf12:esf4, ik:isf7);
        writeln(SparFile,sigma*1e-6);
        dz := 1/ik;
        for i := 0 to ik do
          begin
            z := i*dz;
            writeln(SparFile,z:esf12:esf4,spar_width[i]:esf12:esf4,spar_thick[i]:esf12:esf4);
          end;
        close(SparFile);
        writeln('Ok');
        
    end;
  
  function finish(name:string):boolean;
    var
      hspan, z, x1, x2, x3, x4, sigma:real;
      ik:integer;
      Output:text;
    
    begin
    
      write(' Запись данных крыла и аппарата в файл... ');
      assign(WingFile,FileWing); reset(WingFile);
      assign(Output,name+'\Plane.dat'); rewrite(Output);
      readln(WingFile);readln(WingFile);
      readln(WingFile);readln(WingFile);
      writeln(Output,'# Plane set');
      readln(WingFile, z, x1,x2,x3,x4);
      readln(WingFile,hspan, ik);
      writeln(Output,' Plane mass (g)        : ',z*1e3);
      writeln(Output,' G-force factor (m*s-2): ',x1);
      writeln(Output,' Safety coefficient    : ',x2);
      writeln(Output,' Overload factor       : ',x3);
      writeln(Output,' Wing span (mm)        : ',2*hspan*1e3);
      writeln(Output,' Wing area (dm2)       : ',x4*1e2);
      writeln(Output,' Wing Load (g/dm2)     : ',z/x2*10);
      close(Output);
      
      assign(Output,name+'\Wing.dat'); rewrite(Output);
      writeln(Output,'# Wing chord (mm), thickness (mm), sweep (mm) VS span coordinate (mm)');
      while (not(eof(WingFile))) do
        begin
          readln(WingFile,z,x1,x2,x3);
          writeln(Output,(z*1e3):esf20:esf4, (x1*1e3):esf20:esf4, (x2*x1*10):esf20:esf4, (x3*1e3):esf20:esf4);
        end;
      close(WingFile);
      close(Output);
      writeln('Ok');
      
      write(' Запись таблицы распределения подъемной силы крыла... ');
      assign(WingLoadFile,FileWingLoad); reset(WingLoadFile);
      assign(Output,name+'\WingLoad.dat'); rewrite(Output);
      writeln(Output,'# WingLoad (Local Lift) (kG/m) VS span coordinate (mm)');
      readln(WingLoadFile);readln(WingLoadFile);
      readln(WingLoadFile);readln(WingLoadFile);
      while (not(eof(WingLoadFile))) do
        begin
          readln(WingLoadFile,z,x1);
          writeln(Output,z*hspan*1e3:esf20:esf4, x1:esf20:esf4);
        end;
      close(WingLoadFile);
      close(Output);
      writeln('Ok');
      
      write(' Запись таблицы распределения перерезывающих сил... ');
      assign(ShForceFile,FileShForce); reset(ShForceFile);
      assign(Output,name+'\ShearingForces.dat'); rewrite(Output);
      writeln(Output,'# Shearing Forces (kG) VS span coordinate (mm)');
      readln(ShForceFile);readln(ShForceFile);
      readln(ShForceFile);readln(ShForceFile);
      while (not(eof(ShForceFile))) do
        begin
          readln(ShForceFile,z,x1);
          writeln(Output,z*hspan*1e3:esf20:esf4, x1:esf20:esf4);
        end;
      close(ShForceFile);
      close(Output);
      writeln('Ok');
      
      write(' Запись таблицы распределения изгибающего момента... ');
      assign(BendMomFile,FileBendMom); reset(BendMomFile);
      assign(Output,name+'\BendingMomentum.dat'); rewrite(Output);
      writeln(Output,'# Bending Momentum (kG*m) VS span coordinate (mm)');
      readln(BendMomFile);readln(BendMomFile);
      readln(BendMomFile);readln(BendMomFile);
      while (not(eof(BendMomFile))) do
        begin
          readln(BendMomFile,z,x1);
          writeln(Output,z*hspan*1e3:esf20:esf4, x1:esf20:esf4);
        end;
      close(BendMomFile);
      close(Output);
      writeln('Ok');
      
      write(' Запись геометрических параметров лонжерона в файл... ');
      assign(SparFile,FileSpar); reset(SparFile);
      assign(Output,name+'\Spar.dat'); rewrite(Output);
      writeln(Output,'# Spar width (mm), Spar thickness (mm) VS span coordinate (mm)');
      readln(SparFile);readln(SparFile);readln(SparFile);
      readln(SparFile);readln(SparFile);
      readln(SparFile, sigma);
      writeln(Output,' Sigma (sthengh limit): ',sigma:esf20:esf4);
      while (not(eof(SparFile))) do
        begin
          readln(SparFile,z,x1,x2);
          writeln(Output,z*hspan*1e3:esf20:esf4, x1*1e3:esf20:esf4, x2*1e3:esf20:esf4);
        end;
      close(SparFile);
      close(Output);
      writeln('Ok');
      
      result := true;
    end;
      
  begin
  
  Welkom();
  
  writeln(' Welcome to SPAR STRENGH Calculator');
  sleep(1000);
  
  WrBeg();
  
  SPARSTRENGH();
  
  mkdir('TEMP');
  
  name := Naam();
  
  while (not(lexit)) do
    begin
    	
    	writeln;
    	
    	sleep(500);
    	if (lspar)  then writeln(' > finish    --- для сохранения расчетных данных и завершения программы');
      if (lbemom) then writeln(' > spar      --- для расчета прочности лонжерона ))) ');
      if (lshfor) then writeln(' > bemom     --- для расчета распределения изгибающего момента');
      if (lwload) then writeln(' > shfor     --- для расчета распределения перерезывающих сил');
      if (lwing)  then writeln(' > wload     --- для расчета распределения подъемной силы');
      if (lplane) then writeln(' > defwing   --- для построения расчетной сетки (MESH)');
      if (lplane) then writeln(' > wrscript  --- для записи характеристик крыла в скрипт-файл');
                			 writeln(' > setwing   --- для расчета Нового крыла');
    					         writeln(' > script    --- для считывания характеристик крыла из скрипт-файла');
    					         writeln(' > exit      --- для выхода из программы');
    
        write(' > ');
    	readln(comand);
    	
    	
    /// Set Wing
    	// read script
    		if ((comand='script') or (comand='SCRIPT')) then
    			begin
    				write(' Введите имя скрипт-файла: ');
    				readln(dir);
    				fexists := plane_script(dir,true);
    				if (fexists) then lplane := true;
    				continue;
    			end
    		else if ((comand='setwing') or (comand='SETWING')) then
    			begin
    				Set_Plane();
    				lplane := true;
    				continue;
    			end
    		
    	// write script
    		else if (lplane and ((comand='wrscript') or (comand='WRSCRIPT')) ) then
    			begin
    				write(' Введите имя скрипт-файла: ');
    				readln(dir);
    				plane_script(dir,false);
    				writeln;
    				writeln(' Скрипт-файл с именем ',dir+ScriptWing,' успешно создан');
    				continue;
    			end
    		
    /// Wing definw - preparation to WLOAD subroutine		
    		else if (lplane and ((comand='defwing') or (comand='DEFWING')) ) then
    			begin
    				Set_Wing();
    				writeln;
    				writeln(' Данные для WLOAD обновлены ');
    				lwing := true;
    				continue;
    			end
    			
    /// Wingload Calculator
    		else if (lwing and ((comand='wload') or (comand='WLOAD')) ) then
    			begin
    				WingLoad();
    				writeln;
    				writeln(' Расчет распределения подъемной силы завершен ');
    				lwload := true;
    				continue;
    			end
    			
    /// Shearing Forces Calculator
    		else if (lwload and ((comand='shfor') or (comand='SHFOR')) ) then
    			begin
    				ShForce();
    				writeln;
    				writeln(' Расчет распределения перерезывающих сил завершен ');
    				lshfor := true;
    				continue;
    			end
    			
    /// Bending Momentum Calculator
    		else if (lshfor and ((comand='bemom') or (comand='BEMOM')) ) then
    			begin
    				BendMom();
    				writeln;
    				writeln(' Расчет распределения изгибающего момента завершен ');
    				lbemom := true;
    				continue;
    			end
    			
    /// Spar width Calculator
    		else if (lbemom and ((comand='spar') or (comand='SPAR')) ) then
    			begin
    				sparcalc();
    				writeln;
    				writeln(' Расчет лонжерона завершен ');
    				lspar := true;
    				continue;
    			end
    			
    /// Finish calculation
    		else if (lspar and ((comand='finish') or (comand='FINISH')) ) then
    			begin
    				lexit := finish(name);
    				break;
    			end
    		
    /// Exit, Halt the program		
    		else if ((comand='exit') or (comand='EXIT')) then
    			begin
    				Terminate();
    				writeln;
    				writeln(' Arnie terminated the program...');
    				sleep(1000);
    				writeln(' or...');
    				sleep(1000);
    				writeln(' The program is terminated by User / Программа прервана Пользователем ');
    				sleep(3000);
    				halt;
    			end
    		
    		else
    			begin
    				writeln(' Error! Unknown comand / Ошибка! Неизвестная команда');
    				continue;
    			end;
    		
	  end;
	
	writeln;
	writeln(' Расчет завершен ');
	writeln;
	Arnie();
	writeln;
	writeln(' Теперь лонжерон такой же мощный как Арни :-)');
	writeln;
	writeln(' Hasta la vista, proger! ');
	writeln;
	writeln(' Нажмите Enter для завершения ');
	
	read(dir);
				
  end.
        